Option Explicit

Const JPGILLU_APP = "jpgIlluminator.exe"
Const JPGILLU_FRIENDLYNAME = "JPG-Illuminator"
Const JPGILLU_DESCRIPTION = "Bearbeitet Bilddateien im JPEG-Format"
Const JPGILLU_APPDATAFOLDER = "jpg-Illuminator"
Const JPGILLU_VERB = "ffnen mit JPG-Illuminator"

Dim shell
Dim fso
Dim appPath

Set shell = CreateObject("WScript.Shell")
Set fso = CreateObject("Scripting.FileSystemObject")

appPath= shell.CurrentDirectory
If Right(appPath, 1) <> "\" Then
	appPath = appPath & "\"
End If
appPath = appPath & JPGILLU_APP

If Not fso.FileExists(appPath) Then
	MsgBox JPGILLU_FRIENDLYNAME & " konnte nicht installiert werden." & vbCrLf & "Die Programmdatei wurde nicht gefunden.", _
		vbCritical, JPGILLU_FRIENDLYNAME
Else
	On Error Resume Next
	' optional entries
	shell.RegWrite "HKCR\jpegfile\shell\" & JPGILLU_VERB & "\command\", """" & appPath & """ ""%1"""
	shell.RegWrite "HKCR\Paint.Picture\shell\" & JPGILLU_VERB & "\command\", """" & appPath & """ ""%1"""
	shell.RegWrite "HKCR\.bmp\OpenWithList\" & JPGILLU_APP & "\", Empty
	' standard entries
	Err.Clear
	shell.RegWrite "HKCR\Applications\" & JPGILLU_APP & "\shell\open\FriendlyAppName", JPGILLU_FRIENDLYNAME
	shell.RegWrite "HKCR\Applications\" & JPGILLU_APP & "\shell\open\command\", """" & appPath & """ ""%1"""
	shell.RegWrite "HKCR\.jpg\OpenWithList\" & JPGILLU_APP & "\", Empty
	If Err.Number = 0 Then
		CreateDesktopShortcut JPGILLU_FRIENDLYNAME, appPath, JPGILLU_DESCRIPTION
	End If
	If Err.Number = 0 Then
		MsgBox JPGILLU_FRIENDLYNAME & " wurde erfolgreich installiert.", vbInformation, JPGILLU_FRIENDLYNAME
	Else
		MsgBox "Bei der Installation von " & JPGILLU_FRIENDLYNAME & " ist ein Fehler aufgetreten:" & vbCrLf & _
			Err.Source & ": " & Err.Description & vbCrLf & _
			"Mglicherweise verfgen Sie nicht ber die Berechtigung diesen Vorgang durchzufhren.", _
			vbCritical, JPGILLU_FRIENDLYNAME
	End If
	On Error GoTo 0
End If

Private Function CreateShortcut(ByVal aLinkPath, ByVal aTargetPath, ByVal aDescription, ByVal aWorkingDirectory)
	Dim oShellLink
	Dim ErrNumber, ErrSource, ErrDescription

	' store error information
	ErrNumber = Err.Number
	ErrSource = Err.Source
	ErrDescription = Err.Description

	On Error Resume Next

	Set oShellLink = shell.CreateShortcut(aLinkPath & ".lnk")

	oShellLink.TargetPath = aTargetPath
	oShellLink.Description = aDescription
	oShellLink.WorkingDirectory = aWorkingDirectory

	oShellLink.Save

	CreateShortcut = CBool(Err.Number = 0)

	If ErrNumber <> 0 Then
		' restore previous error information
		Err.Raise ErrNumber, ErrSource, ErrDescription
	Else
		Err.Clear
	End If
End Function

Private Sub CreateDesktopShortcut(ByVal aLinkName, ByVal aTargetPath, ByVal aDescription)
	Dim strDesktop

	strDesktop = shell.SpecialFolders("AllUsersDesktop")
	If Len(strDesktop) > 0 Then
		' try allusers desktop
		If Not CreateShortcut(strDesktop & "\" & aLinkName, aTargetPath, aDescription, "") Then
			strDesktop = ""
		End If
	End If
	If Len(strDesktop) = 0 Then
		' try current desktop
		strDesktop = shell.SpecialFolders("Desktop")
		CreateShortcut strDesktop & "\" & aLinkName, aTargetPath, aDescription, strDesktop
	End If
End Sub
