Option Explicit

Const JPGILLU_APP = "jpgIlluminator.exe"
Const JPGILLU_OLDFRIENDLYNAME = "JPEG-Illuminator"
Const JPGILLU_FRIENDLYNAME = "JPG-Illuminator"
Const JPGILLU_DESCRIPTION = "Bearbeitet Bilddateien im JPEG-Format"
Const JPGILLU_APPDATAFOLDER = "jpg-Illuminator"
Const JPGILLU_VERB = "ffnen mit JPG-Illuminator"

Dim shell
Dim fso
Dim appKey

If MsgBox("Hiermit wird " & JPGILLU_FRIENDLYNAME & " deinstalliert. Das Programm wird nicht gelscht, " & _
          "jedoch werden die Explorer-Meneintrge und die Desktop-Verknpfung von " & _
          JPGILLU_FRIENDLYNAME & " entfernt." & vbcrlf & vbCrLf & _
          "Mchten Sie mit der Deinstallation fortfahren?", vbExclamation + vbYesNo + vbDefaultButton2, JPGILLU_FRIENDLYNAME) = vbYes Then
          
	Set shell = CreateObject("WScript.Shell")
	Set fso = CreateObject("Scripting.FileSystemObject")
	
	On Error Resume Next
	appKey = ""
	appKey = shell.RegRead("HKCR\Applications\" & JPGILLU_APP & "\shell\open\command\")
	On Error GoTo 0
	
	If Len(appKey) = 0 Then
		MsgBox JPGILLU_FRIENDLYNAME & " ist nicht installiert.", vbExclamation, JPGILLU_FRIENDLYNAME
	Else
		On Error Resume Next
		' optional entries
		shell.RegDelete "HKCR\jpegfile\shell\" & JPGILLU_VERB & "\command\"
		shell.RegDelete "HKCR\jpegfile\shell\" & JPGILLU_VERB & "\"
		shell.RegDelete "HKCR\Paint.Picture\shell\" & JPGILLU_VERB & "\command\"
		shell.RegDelete "HKCR\Paint.Picture\shell\" & JPGILLU_VERB & "\"
		shell.RegDelete "HKCR\.bmp\OpenWithList\" & JPGILLU_APP & "\"
		' standard entries
		Err.Clear
		shell.RegDelete "HKCR\Applications\" & JPGILLU_APP & "\shell\open\command\"
		shell.RegDelete "HKCR\Applications\" & JPGILLU_APP & "\shell\open\"
		shell.RegDelete "HKCR\Applications\" & JPGILLU_APP & "\shell\"
		shell.RegDelete "HKCR\Applications\" & JPGILLU_APP & "\"
		shell.RegDelete "HKCR\.jpg\OpenWithList\" & JPGILLU_APP & "\"
		RemoveDesktopShortcut JPGILLU_OLDFRIENDLYNAME
		RemoveDesktopShortcut JPGILLU_FRIENDLYNAME
		If MsgBox("Sollen die zuletzt benutzten Einstellungen und Filter-Presets von " & JPGILLU_FRIENDLYNAME & " ebenfalls entfernt werden?" & vbcrlf & vbCrLf & _
		          "Antworten Sie mit Nein, wenn Sie diese Einstellungen spter noch bentigen.", vbQuestion + vbYesNo + vbDefaultButton2, JPGILLU_FRIENDLYNAME) = vbYes Then
			RemoveAppDataFolder JPGILLU_APPDATAFOLDER
		End If
		If Err.Number = 0 Then
			MsgBox JPGILLU_FRIENDLYNAME & " wurde erfolgreich deinstalliert.", vbInformation, JPGILLU_FRIENDLYNAME
		Else
			MsgBox "Bei der Deinstallation von " & JPGILLU_FRIENDLYNAME & " ist ein Fehler aufgetreten:" & vbCrLf & _
				Err.Source & ": " & Err.Description & vbCrLf & _
				"Mglicherweise verfgen Sie nicht ber die Berechtigung diesen Vorgang durchzufhren.", _
				vbCritical, JPGILLU_FRIENDLYNAME
		End If
		On Error GoTo 0
	End If
	
End If

Private Function RemoveShortcut(ByVal aLinkPath)
	Dim ErrNumber, ErrSource, ErrDescription

	' store error information
	ErrNumber = Err.Number
	ErrSource = Err.Source
	ErrDescription = Err.Description

	On Error Resume Next

	fso.DeleteFile aLinkPath & ".lnk"

	RemoveShortcut = CBool(Err.Number = 0)

	If ErrNumber <> 0 Then
		' restore previous error information
		Err.Raise ErrNumber, ErrSource, ErrDescription
	Else
		Err.Clear
	End If
End Function

Private Sub RemoveDesktopShortcut(ByVal aLinkName)
	Dim strDesktop

	strDesktop = shell.SpecialFolders("AllUsersDesktop")
	If Len(strDesktop) > 0 Then
		RemoveShortcut strDesktop & "\" & aLinkName
	End If

	strDesktop = shell.SpecialFolders("Desktop")
	RemoveShortcut strDesktop & "\" & aLinkName
End Sub

Private Sub RemoveAppDataFolder(ByVal aFolderName)
	Dim sAppDataFolder

	sAppDataFolder = shell.SpecialFolders("AppData")

	If Len(sAppDataFolder) > 0 Then
		sAppDataFolder = sAppDataFolder & "\" & aFolderName
		If fso.FolderExists(sAppDataFolder) Then
			fso.DeleteFolder sAppDataFolder
		End If
	End If
End Sub
